//+------------------------------------------------------------------+
//|                                                     Hedge_EA.mq4 |
//|                             Alexey Gnetko (kreed131 at mql5.com) |
//|                                               kreed131@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Alexey Gnetko (kreed131 at mql5.com)"
#property link      "kreed131@gmail.com"
#property version   "1.00"
#property strict

input int MagicNumber = 0; //Magic Number (if 0 = for all orders)
input double LotCoeff = 1; //Lot Coefficient for hedge orders
input int StartHedging = 500; //Start Hedge from loss (points)
input int StopHedging = 300; //Close Hedge from profit (points)
int HedgeMagic = 15215;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   OrderSend(Symbol(), OP_BUY, 0.01, Ask, 5, 0, Ask+1000*Point, "");
   OrderSend(Symbol(), OP_SELL, 0.01, Bid, 5, 0, Bid-1000*Point, "");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int numOfOrders = OrdersTotal(), ticket;
   bool cont = 0;
         
   for(int index = numOfOrders - 1; index >= 0; index--)
   {
      cont = 0;
      OrderSelect(index, SELECT_BY_POS, MODE_TRADES);
      ticket = OrderTicket();
      if (OrderSymbol() == Symbol() && ((MagicNumber != 0 && OrderMagicNumber() == MagicNumber) || MagicNumber == 0) && ProfitPoints(OrderType(), OrderOpenPrice()) <= (-1)*StartHedging && (OrderType() == OP_BUY || OrderType() == OP_SELL) && (StringFind(OrderComment(), "hedge #", 0) == -1))
      {
         for(int i = OrdersTotal() - 1; i >= 0; i--)
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(StringFind(OrderComment(), "hedge #"+ticket, 0) != -1) 
               cont = 1;
            //Print(OrderComment() + " " + cont);
         }
         OrderSelect(index, SELECT_BY_POS, MODE_TRADES);      
            
         if(cont) continue;
         else OrderSend(Symbol(), OrderType() == OP_BUY ? OP_SELL : OP_BUY, NormalizeDouble(OrderLots()*LotCoeff, 2), OrderType() == OP_BUY ? Bid : Ask, 5, 0, 0, "hedge #"+OrderTicket(), HedgeMagic);
      }     
    }   
     
   for(int index = OrdersTotal() - 1; index >= 0; index--)
   {
      OrderSelect(index, SELECT_BY_POS, MODE_TRADES);
      cont = 0;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == HedgeMagic)
      {
         ticket = StringToInteger(StringSubstr(OrderComment(), 7));
         Print(ticket);
         for(int i = OrdersTotal() - 1; i >= 0; i--)
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderTicket() == ticket && ProfitPoints(OrderType(), OrderOpenPrice()) <= StopHedging) { cont = 1; break; }
         }
         OrderSelect(index, SELECT_BY_POS, MODE_TRADES);    
         if(!cont) OrderClose(OrderTicket(), OrderLots(), OrderType() == OP_BUY ? Bid : Ask, 5);  
       }    
     }
  }
//+------------------------------------------------------------------+
int ProfitPoints(int ord, double openPrice)
{
   int PointProfit = 0;
   //Print(OrderOpenPrice()+ " " + Bid + " " + (OrderOpenPrice() - Bid)/Point);
   if(ord == OP_BUY) PointProfit = MathFloor((Bid-openPrice)/Point);
   if(ord == OP_SELL) PointProfit = MathFloor((openPrice-Ask)/Point);
   
   return PointProfit;
}